package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import bean.Category;
import util.DBUtil;

public class CategoryDAO {
	public int getTotal(){
		String sql="select count(*) from category";
		int total=0;
		try(Connection c=DBUtil.getConnection();
				Statement s=c.createStatement();) {
			ResultSet rs=s.executeQuery(sql);
			while(rs.next()){
				total=rs.getInt(1);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return total;
	}
	
	public List<Category> list(int start,int count){
		List<Category> categories=new ArrayList<Category>();
		String sql="select * from category order by id limit ?,?";
		try (Connection c=DBUtil.getConnection();
				PreparedStatement ps=c.prepareStatement(sql);){
			ps.setInt(1, start);
			ps.setInt(2, count);
			ResultSet rs=ps.executeQuery();
			while(rs.next()){
				Category category=new Category();
				category.setId(rs.getInt(1));
				category.setName(rs.getString(2));
				categories.add(category);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return categories;
	}
	public void add(Category bean){
		String sql="insert into category values(null,?)";
		try(Connection c=DBUtil.getConnection();
				PreparedStatement ps=c.prepareStatement(sql);) {
			ps.setString(1, bean.getName());
			ps.execute();
			ResultSet rs=ps.getGeneratedKeys();
			while(rs.next()){
				bean.setId(rs.getInt(1));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
	}
    public void delete(int id){
    	String sql="delete from category where id="+id;
    	try(Connection c=DBUtil.getConnection();
    			Statement s=c.createStatement();){
			s.execute(sql);
		} catch (Exception e) {
			// TODO: handle exception
		}
    }
    public Category get(int id){   	
    	String sql="select * from category where id="+id;
    	Category category=new Category();
    	try(Connection c=DBUtil.getConnection();
    			Statement s=c.createStatement();) {
			ResultSet rs=s.executeQuery(sql);
			while(rs.next()){
				category.setId(rs.getInt(1));
				category.setName(rs.getString(2));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
    	return category;
    }
    public void update(Category bean){
    	String sql="update category set name=? where id=?";
    	try(Connection c=DBUtil.getConnection();
    			PreparedStatement ps=c.prepareStatement(sql);) {
			ps.setString(1, bean.getName());
			ps.setInt(2, bean.getId());
			ps.execute();
		} catch (Exception e) {
			// TODO: handle exception
		}
    }
    
}
