package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import bean.Category;
import bean.Product;
import bean.ProductImage;
import bean.Property;
import util.DBUtil;
import util.DateUtil;

public class ProductDAO {
	public void setFirstProductImage(Product p) {
        List<ProductImage> pis= new ProductImageDAO().list(p.getId(),"type_single");
        if(!pis.isEmpty()){
        	p.setFirstProductImage(pis.get(0));
        }  
    }
	
	public int getTotal(int cid){
		String sql="select count(*) from product where cid="+cid;
		int total=0;
		try(Connection c=DBUtil.getConnection();
				Statement s=c.createStatement();) {
			ResultSet rs=s.executeQuery(sql);
			while(rs.next()){
				total=rs.getInt(1);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return total;
	}
	
	public List<Product> list(int start,int count,Category category){
		List<Product> products=new ArrayList<>();
		String sql="select * from product where cid=? order by id limit ?,?";
		try (Connection c=DBUtil.getConnection();
				PreparedStatement ps=c.prepareStatement(sql);){
			ps.setInt(1, category.getId());
			ps.setInt(2, start);
			ps.setInt(3, count);
			ResultSet rs=ps.executeQuery();
			while(rs.next()){
				Product product=new Product();
				product.setId(rs.getInt(1));
				product.setName(rs.getString(2));
				product.setSubTitle(rs.getString(3));
				product.setOrignalPrice(rs.getFloat(4));
				product.setPromotePrice(rs.getFloat(5));
				product.setStock(rs.getInt(6));
				product.setCategory(category);
				//漰ʱҪ
				Date createDate = DateUtil.t2d( rs.getTimestamp("createDate"));
				
				product.setCreateDate(createDate);
				setFirstProductImage(product);
				products.add(product);
				setFirstProductImage(product);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return products;
	}
	public void add(Product bean){
		String sql="insert into product values(null,?,?,?,?,?,?,?)";
		try(Connection c=DBUtil.getConnection();
				PreparedStatement ps=c.prepareStatement(sql);) {
			ps.setString(1, bean.getName());
			ps.setString(2, bean.getSubTitle());
			ps.setFloat(3, bean.getOrignalPrice());
			ps.setFloat(4, bean.getPromotePrice());
			ps.setInt(5, bean.getStock());
			ps.setInt(6, bean.getCategory().getId());
			ps.setTimestamp(7, DateUtil.d2t(bean.getCreateDate()));//ע⡣
			
			ps.execute();
			ResultSet rs=ps.getGeneratedKeys();
			while(rs.next()){
				bean.setId(rs.getInt(1));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
	}
    public void delete(int id){
    	String sql="delete from product where id="+id;
    	try(Connection c=DBUtil.getConnection();
    			Statement s=c.createStatement();){
			s.execute(sql);
		} catch (Exception e) {
			// TODO: handle exception
		}
    }
    public Product get(int id){   	
    	String sql="select * from product where id="+id;
    	Product product=new Product();
    	try(Connection c=DBUtil.getConnection();
    			Statement s=c.createStatement();) {
			ResultSet rs=s.executeQuery(sql);
			while(rs.next()){
				product.setId(rs.getInt(1));
				product.setName(rs.getString(2));
				product.setSubTitle(rs.getString(3));				
				product.setOrignalPrice(rs.getFloat(4));
				product.setPromotePrice(rs.getFloat(5));
				product.setStock(rs.getInt(6));
                
				Date createDate = DateUtil.t2d( rs.getTimestamp("7"));
				product.setCreateDate(createDate);	
				
				setFirstProductImage(product);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
    	return product;
    }
    public void update(Product bean){
    	String sql="update product set name=?, subTitle=?, orignalPrice=?,promotePrice=?,"
    			+ "stock=? where id=?";
    	try(Connection c=DBUtil.getConnection();
    			PreparedStatement ps=c.prepareStatement(sql);) {
    		ps.setString(1, bean.getName());
            ps.setString(2, bean.getSubTitle());
            ps.setFloat(3, bean.getOrignalPrice());
            ps.setFloat(4, bean.getPromotePrice());
            ps.setInt(5, bean.getStock());
            ps.setInt(6, bean.getId());
			ps.execute();
		} catch (Exception e) {
			// TODO: handle exception
		}
    }
}
