package servlet;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import bean.Category;
import dao.CategoryDAO;
import util.ImageUtil;

public class CategoryServlet extends BaseBackServlet{
	public void add(HttpServletRequest request,HttpServletResponse response) throws Exception{
		Map<String, String> params=new HashMap<>();
		InputStream is=null;
    	Category category=new Category();
    	//
    	is=super.upload(request,params);
    	//
    	category.setName(params.get("name"));
    	new CategoryDAO().add(category);
    	//ύͼƬ
    	int id=category.getId();
    	String context="img/category";
    	super.saveUplod(request, is, id,context);
    	   	
    	response.sendRedirect("admin_category_list");
	}
    public void delete(HttpServletRequest request,HttpServletResponse response) throws IOException{
    	int id=Integer.parseInt(request.getParameter("id"));
    	new CategoryDAO().delete(id);
    	
    	String filePath=request.getSession().getServletContext().getRealPath("img/category");
    	String fileName=id+".jpg";
    	File imageFile = new File(filePath+"/"+fileName);
    	imageFile.delete();
    	
    	response.sendRedirect("admin_category_list");
    }
    public void edit(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int id = Integer.parseInt(request.getParameter("id"));
    	Category c = new CategoryDAO().get(id);
    	request.setAttribute("c", c);
    	request.getRequestDispatcher("/admin/category/categoryEdit.jsp").forward(request, response);
    
    }
    public void update(HttpServletRequest request,HttpServletResponse response) throws Exception{
        InputStream is=null;
        Category category=new Category();
        Map<String, String> params=new HashMap<>();
        //
        is=super.upload(request, params);
        //
        category.setId(Integer.parseInt(params.get("id")));
        category.setName(params.get("name"));
        new CategoryDAO().update(category);
        //ļͼƬ
        String context="img/category";
        saveUplod(request, is, category.getId(),context);
       
    	response.sendRedirect("admin_category_list");
    }
    public void list(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int start=0;//ʼҳʼֵ
    	int count=5;//ɱ䡿
    	
    	try {//вstartҪtryĴ
    		start=Integer.parseInt(request.getParameter("start"));
		} catch (NumberFormatException e) {
			// TODO: handle exception
		}
    	
    	List<Category>categories=new CategoryDAO().list(start,count);
    	
    	int total=new CategoryDAO().getTotal();//
    	
    	
    	int last=0;//ĩҳʼֵ
    	if(0==total%count)
    		last=total - count;
    	else
    		last=total - total % count;
 
    	int pre=start-count;//һҳʼֵ
    	pre=pre>0?pre:0;//߽紦
    	int next=start+count;//һҳʼֵ
    	next=next<last?next:last;//߽紦
    	
    	int page=0;//ҳ
    	if(0==total%count)
    		page=total / count;
    	else
    		page=total / count+1;
    
    	
    	request.setAttribute("pre", pre);//preݸjsp
    	request.setAttribute("next", next);//nextݸjsp
    	request.setAttribute("last", last);//lastݸjsp
    	request.setAttribute("page", page);//pageݸjsp
    	request.setAttribute("count", count);//countݸjsp
    	request.setAttribute("categories", categories);//categoriesݸjsp
    	request.getRequestDispatcher("/admin/category/categoryList.jsp").forward(request, response);
    
    }
}
