package servlet;

import java.io.IOException;
import java.util.Date;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import bean.Category;
import bean.Product;
import bean.Property;
import dao.CategoryDAO;
import dao.ProductDAO;
import dao.PropertyDAO;

public class ProductServlet extends BaseBackServlet{
public void add(HttpServletRequest request,HttpServletResponse response) throws Exception{
		
	    Product product=new Product();
    	String name=request.getParameter("name");
    	String subTitle=request.getParameter("subTitle");
    	Float orignalPrice=Float.parseFloat(request.getParameter("orignalPrice"));
    	Float promotePrice=Float.parseFloat(request.getParameter("promotePrice"));
    	int stock=Integer.parseInt(request.getParameter("stock"));
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	
    	product.setName(name);
    	product.setSubTitle(subTitle);
    	product.setOrignalPrice(orignalPrice);
    	product.setPromotePrice(promotePrice);
    	product.setStock(stock);
    	product.setCategory(new CategoryDAO().get(cid));
    	product.setCreateDate(new Date() );
    	
    	new ProductDAO().add(product);
    	
    	   	
    	response.sendRedirect("admin_product_list?cid="+cid);
	}
    public void delete(HttpServletRequest request,HttpServletResponse response) throws IOException{
    	int id=Integer.parseInt(request.getParameter("id"));
    	new ProductDAO().delete(id);
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	
    	response.sendRedirect("admin_product_list?cid="+cid);
    }
    public void edit(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int id = Integer.parseInt(request.getParameter("id"));
    	int cid = Integer.parseInt(request.getParameter("cid"));
    	Product product  = new ProductDAO().get(id);
    	request.setAttribute("product", product);
    	request.setAttribute("cid", cid);
    	request.getRequestDispatcher("/admin/product/productEdit.jsp").forward(request, response);
    
    }
    public void update(HttpServletRequest request,HttpServletResponse response) throws Exception{
        Product product=new Product();
        int id=Integer.parseInt(request.getParameter("id"));
        product=new ProductDAO().get(id);
        
        String name=request.getParameter("name");
        String subTitle=request.getParameter("subTitle");
        float orignalPrice=Float.parseFloat(request.getParameter("orignalPrice"));
        float promotePrice=Float.parseFloat(request.getParameter("promotePrice"));
        int stock=Integer.parseInt(request.getParameter("stock"));
        
        product.setName(name);
        product.setSubTitle(subTitle);
        product.setOrignalPrice(orignalPrice);
        product.setPromotePrice(promotePrice);
        product.setStock(stock);
        
        new ProductDAO().update(product);
        int cid=Integer.parseInt(request.getParameter("cid"));
    	response.sendRedirect("admin_product_list?cid="+cid);
    }
    public void list(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int start=0;//ʼҳʼֵ
    	int count=5;//ɱ䡿
    	
    	try {//вstartҪtryĴ
    		start=Integer.parseInt(request.getParameter("start"));
		} catch (NumberFormatException e) {
			// TODO: handle exception
		}
    	
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	Category c=new CategoryDAO().get(cid);
    	List<Product>products=new ProductDAO().list(start,count,c);
    	request.setAttribute("c", c);//cidݸjsp
    	int total=new ProductDAO().getTotal(cid);//
    	
    	
    	int last=0;//ĩҳʼֵ
    	if(0==total%count)
    		last=total - count;
    	else
    		last=total - total % count;
 
    	int pre=start-count;//һҳʼֵ
    	pre=pre>0?pre:0;//߽紦
    	int next=start+count;//һҳʼֵ
    	next=next<last?next:last;//߽紦
    	
    	int page=0;//ҳ
    	if(0==total%count)
    		page=total / count;
    	else
    		page=total / count+1;
    
    	
    	request.setAttribute("pre", pre);//preݸjsp
    	request.setAttribute("next", next);//nextݸjsp
    	request.setAttribute("last", last);//lastݸjsp
    	request.setAttribute("page", page);//pageݸjsp
    	request.setAttribute("count", count);//countݸjsp
    	request.setAttribute("products", products);//categoriesݸjsp
    	request.getRequestDispatcher("/admin/product/productList.jsp").forward(request, response);
    
    }
}
