package servlet;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import bean.Category;
import bean.Property;
import dao.CategoryDAO;
import dao.PropertyDAO;


public class PropertyServlet extends BaseBackServlet{
	public void add(HttpServletRequest request,HttpServletResponse response) throws Exception{
		
    	Property property=new Property();
    	String name=request.getParameter("name");
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	property.setName(name);
    	property.setCategory(new CategoryDAO().get(cid));
    	
    	new PropertyDAO().add(property);
    	
    	   	
    	response.sendRedirect("admin_property_list?cid="+cid);
	}
    public void delete(HttpServletRequest request,HttpServletResponse response) throws IOException{
    	int id=Integer.parseInt(request.getParameter("id"));
    	new PropertyDAO().delete(id);
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	
    	response.sendRedirect("admin_property_list?cid="+cid);
    }
    public void edit(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int id = Integer.parseInt(request.getParameter("id"));
    	int cid = Integer.parseInt(request.getParameter("cid"));
    	Property p = new PropertyDAO().get(id);
    	request.setAttribute("p", p);
    	request.setAttribute("cid", cid);
    	request.getRequestDispatcher("/admin/property/propertyEdit.jsp").forward(request, response);
    
    }
    public void update(HttpServletRequest request,HttpServletResponse response) throws Exception{
        Property property=new Property();
        int id=Integer.parseInt(request.getParameter("id"));
        property=new PropertyDAO().get(id);
        String name=request.getParameter("name");
        property.setName(name);
        new PropertyDAO().update(property);
        int cid=Integer.parseInt(request.getParameter("cid"));
    	response.sendRedirect("admin_property_list?cid="+cid);
    }
    public void list(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	int start=0;//ʼҳʼֵ
    	int count=5;//ɱ䡿
    	
    	try {//вstartҪtryĴ
    		start=Integer.parseInt(request.getParameter("start"));
		} catch (NumberFormatException e) {
			// TODO: handle exception
		}
    	
    	int cid=Integer.parseInt(request.getParameter("cid"));
    	Category c=new CategoryDAO().get(cid);
    	List<Property>properties=new PropertyDAO().list(start,count,c);
    	request.setAttribute("c", c);//cidݸjsp
    	int total=new PropertyDAO().getTotal(cid);//
    	
    	
    	int last=0;//ĩҳʼֵ
    	if(0==total%count)
    		last=total - count;
    	else
    		last=total - total % count;
 
    	int pre=start-count;//һҳʼֵ
    	pre=pre>0?pre:0;//߽紦
    	int next=start+count;//һҳʼֵ
    	next=next<last?next:last;//߽紦
    	
    	int page=0;//ҳ
    	if(0==total%count)
    		page=total / count;
    	else
    		page=total / count+1;
    
    	
    	request.setAttribute("pre", pre);//preݸjsp
    	request.setAttribute("next", next);//nextݸjsp
    	request.setAttribute("last", last);//lastݸjsp
    	request.setAttribute("page", page);//pageݸjsp
    	request.setAttribute("count", count);//countݸjsp
    	request.setAttribute("properties", properties);//categoriesݸjsp
    	request.getRequestDispatcher("/admin/property/propertyList.jsp").forward(request, response);
    
    }
}
